#
# spec file for package smalltalk (Version 1.95.13a)
#
# Copyright (c) 2004 SUSE LINUX AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  glib glib-devel gtk gtk-devel readline readline-devel tcl tcl-devel te_latex tetex texinfo tk x-devel-packages
# usedforbuild    aaa_base acl attr bash bind9-utils bison coreutils cpio cpp cvs cyrus-sasl2 db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel pam-modules patch permissions ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel XFree86-devel XFree86-libs autoconf automake binutils bzip2 cracklib gcc gdbm gettext glib glib-devel gtk gtk-devel libtool perl readline-devel rpm tcl tcl-devel te_ams te_latex tetex tk

Name:         smalltalk
License:      GPL
Group:        Development/Languages/Other
Obsoletes:    smaltalk
PreReq:       %install_info_prereq
Autoreqprov:  on
Version:      1.95.13a
Release:      267
Summary:      The GNU implementation of the Smalltalk language
URL:          http://www.gnu.org/software/smalltalk/
Source0:      ftp://ftp.gnu.org/pub/gnu/smalltalk/smalltalk-%{version}.tar.bz2
Source1:      xgst
Patch0:       smalltalk-%{version}.patch
Patch1:       smalltalk-tk8.4.patch
Patch2:       smalltalk-%{version}-integer_and_buffer_overflow.patch
Patch3:       smalltalk-%{version}-xpm-sec5.patch
Patch4:       smalltalk-%{version}-xpm-secfix-thomas.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
GNU Smalltalk is an implementation that closely follows the
Smalltalk-80 language as described in the book `Smalltalk-80: the
Language and its Implementation' by Adele Goldberg and David Robson.

The Smalltalk programming language is an object oriented programming
language.  This means that when programming you are thinking of not
only the data that an object contains, but also of the operations
available on that object.  The object's data representation
capabilities and the operations available on the object are
"inseparable." The set of things that you can do with an object is
defined precisely by the set of operations, which Smalltalk calls
"methods", that are available for that object.	You cannot even examine
the contents of an object from the outside.  To an outsider, the object
is a black box that has some state and some operations available, but
that's all you know.

In the Smalltalk language, everything is an object.  This includes
numbers, executable procedures (methods), and stack frames (called
method contexts or block contexts).  Each object is an "instance" of a
"class".  A class can be thought of as a datatype and the set of
functions that operate on that datatype.  An instance is a particular
variable of that datatype. When you want to perform an operation on an
object, you send it a "message", and the object performs an operation
that corresponds to that message.

Unlike other Smalltalks (including Smalltalk-80), GNU Smalltalk
emphasizes Smalltalk's rapid prototyping features rather than the
graphical and easy-to-use nature of the programming environment (did
you know that the first GUIs ran under Smalltalk?).  The availability
of a large body of system classes, once you learn them, makes it easy
to write complex programs which are usually a task for the so called
"scripting languages".	Therefore, even though we have a nice GUI
environment including a class browser, the goal of the GNU Smalltalk
project is to produce a complete system that can be used to write your
scripts in a clear, aesthetically pleasing, and philosophically
appealing programming language.

For a complete explanation of Smalltalk there is a very nice tutorial.
Try the command: "info gst".

Oh, of course GNU Smalltalk has bugs.  And of course I like to hear
from people who have something to say regarding them. So bug reports,
suggestions, help, advice, and source code contributions are all
welcome. All you have to do is send mail to help-smalltalk@gnu.org. An
answer is "almost" guaranteed.



Authors:
--------
    Paolo Bonzini <bonzini@gnu.org>
    Steve Byrne <sbb@gnu.org>

%prep
%setup -q
%patch0
%patch1
%patch2
%patch3
%patch4
#
cp %{S:1} .

%build
%{?suse_update_config:%{suse_update_config -f}}
aclocal -I m4
automake -a
autoconf
CFLAGS="$RPM_OPT_FLAGS" \
CXXFLAGS="$RPM_OPT_FLAGS" \
./configure --prefix=/usr \
	    --libdir=%{_libdir} \
            --infodir=%{_infodir} \
            --mandir=%{_mandir}
cd lib-src
make
cd ..
make

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install
install -m 755 xgst $RPM_BUILD_ROOT/usr/bin/

%clean
rm -rf $RPM_BUILD_ROOT

%post
%install_info --info-dir=%{_infodir} %{_infodir}/gst.info.gz

%preun
%install_info --delete --info-dir=%{_infodir} %{_infodir}/gst.info.gz

%files
%doc AUTHORS COPYING NEWS README THANKS TODO
# docs/gst.dvi.bz2
/usr/bin/gst
# hack for X11
/usr/bin/xgst
/usr/bin/gst-config
/usr/bin/gst-package
# lib and include
%{_libdir}/*
/usr/include/*
/usr/share/smalltalk
%doc %{_infodir}/gst.info*.gz
%doc %{_mandir}/man1/gst.1.gz

%changelog -n smalltalk
* Fri Oct 22 2004 - pmladek@suse.cz
- fixed potential integer and buffer overflow in the code from libXpm [#43240]
* Wed Mar 12 2003 - pmladek@suse.cz
- really added x-devel-packages to neededforbuild to build with
  Tcl/Tk support again
* Tue Feb 18 2003 - pmladek@suse.cz
- Use %%install_info macro [#23458]
* Mon Nov 11 2002 - ro@suse.de
- changed neededforbuild <xf86 xdevel> to <x-devel-packages>
* Tue Sep 17 2002 - ro@suse.de
- removed bogus self-provides
* Fri Jul 12 2002 - max@suse.de
- Fixed for Tcl/Tk 8.4.
* Tue Jul 09 2002 - pmladek@suse.cz
- updated to version 1.95.13a, bugfix release
- removed ppc workaround (-fsigned-char is in $RPM_OPT_FLAGS on ppc)
* Mon Apr 08 2002 - pmladek@suse.cz
- used suse_update_config
- removed obsolete --host=%%{_target_cpu}-suse-linux configure parametr
* Fri Apr 05 2002 - schwab@suse.de
- Remove ia64 workaround.
- Fix typo in LP64 patches.
* Tue Apr 02 2002 - pmladek@suse.cz
- fixed to compile with autoconf-2.53:
- used macro AC_LIBOBJ
- added glib-devel and gtk-devel into neededforbuild
- used aclocal
* Wed Jan 23 2002 - pmladek@suse.cz
- used macro %%{_libdir} to fix for lib64
* Fri Jan 18 2002 - pmladek@suse.cz
- updated to version 1.95.9:
  * improved SortedCollection performance
  * the directory class>>#image method returns the *current*
  rather than the default image path
  * a few bug fixes
* Tue Dec 18 2001 - pmladek@suse.cz
- updated to version 1.95.7, bugfix release
* Wed Nov 21 2001 - schwab@suse.de
- Workaround gcc bug on ia64 with -frename-registers.
- Add some casts for 64 bit architectures.
- Fix use of old readline API.
- Fix xgst script.
* Wed Nov 21 2001 - schwab@suse.de
- Fix to build on architectures that have no asm support for lightning.
* Mon Nov 19 2001 - ro@suse.de
- update to 1.95.5 to make it build again
* Wed Aug 15 2001 - pmladek@suse.cz
- fixed to realy compile with $RPM_OPT_FLAGS
- removed xgst from patch to sources
- fixed xgst to run blox/Run.st only now
* Mon Jun 18 2001 - schwab@suse.de
- Fix C function interface for ia64.
* Mon Jun 18 2001 - schwab@suse.de
- Don't run autoconf.
- Fix use of va_arg.
* Wed Jun 13 2001 - pblaha@suse.cz
- fix libblox-tk for work xgst
* Tue Jun 12 2001 - pblaha@suse.cz
- fix compilation with new autoconf
* Tue May 08 2001 - mfabian@suse.de
- bzip2 sources
* Fri Mar 23 2001 - pblaha@suse.cz
- update on 1.95.4
* Tue Mar 13 2001 - ro@suse.de
- fixed problem with TK_XINCLUDES
* Fri Feb 23 2001 - ro@suse.de
- added readline/readline-devel to neededforbuild (split from bash)
* Thu Jan 25 2001 - pblaha@suse.cz
- update on 1.8.5
* Wed Nov 29 2000 - ro@suse.de
- changed neededforbuild <tcld> to <tcl-devel>
* Mon Nov 27 2000 - pblaha@suse.cz
- upgrade on 1.8.4 and fix problem with run xgst
* Tue Nov 14 2000 - pblaha@suse.cz
- rename to smalltalk
* Wed Oct 04 2000 - pblaha@suse.cz
- upgrade to 1.8.3
* Wed Jun 21 2000 - uli@suse.de
- fixed for PPC
* Mon Jun 19 2000 - kasal@suse.de
- upgrade to 1.7.5
* Thu Jun 08 2000 - ro@suse.de
- hacked configure for tcl 8.3
* Mon Mar 27 2000 - kasal@suse.cz
- upgrade to 1.7.3
* Tue Feb 29 2000 - kasal@suse.cz
- upgraded to 1.7.1
- added buildroot, got rid of Makefile.Linux
- does not provide stix
* Mon Feb 28 2000 - kukuk@suse.de
- move /usr/info -> /usr/share/info
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Mon Dec 14 1998 - ro@suse.de
- build with glibc
- use configure-switch to compile in runtime-locations
* Thu Oct 02 1997 - rj@suse.de
- version 1.2.alpha5 now working with build
* Thu Jan 02 1997 - rj@suse.de
- package included again
- new version 1.2.alpha5 (ELF-Binaries)
- now including blox, stix and tcp
